// O(m + n)
// DF()  pt retinerea nodurilor in ordinea timpilor de finish
// DFT() pe graful transpus in ordinea scaderii timpilor de finish

#include <fstream.h>
#define DIM 100

int a[DIM][DIM], n;
int v[DIM];
int s[DIM];
int term[DIM];
int nrc;

ofstream fout("gr.out");
int timp;

void Read(char num[]);
void Afis(char num[]);
void DF(int nod);
void DFT(int nod);
void TareConexe();

int main()
{
    Read("gr.in");
	TareConexe();
	fout.close();

	return 0;
}

void DF(int nod)
{
	v[nod] = 1;
	for ( int i = 1; i <= n; i++ )
		if ( a[nod][i] && !v[i] ) DF( i );
    timp++;
	term[timp] = nod;
}

void DFT(int nod)  // Deep First pe graful transpus
{
	s[nod] = 1;
	fout << nod << " ";
	for ( int i = 1; i <= n; i++ )
		if ( a[i][nod] && !s[i] ) DFT( i );
}

void Read(char num[])
{
	ifstream fin(num);
	fin >> n;
	int i, j;

	while ( fin >> i >> j )
		a[i][j] = 1;

	fin.close();
}

void TareConexe()
{
    int i;
    memset(v, 0, sizeof(v));
    for ( i = 1; i <= n; i++ )
	if ( !v[i] ) DF(i);

    memset(s, 0, sizeof(s));
    for ( int t = n; t >= 1; t-- ) // pt fiecare unitate de timp t
	if ( !s[term[t]] )     // term[t] - nodul care a fost terminat la momentul t
	{
	     fout << "comp nr " << ++nrc << " : ";
	     DFT(term[t]);
	     fout << "\n";
	}
}


